-include .make/base.mk
-include .make/python.mk
-include .make/terraform.mk
-include $(BASE_PATH)/PrivateRules.mak

SHELL=/usr/bin/env bash

PYTHON_LINT_TARGET=scripts openstack-instance/scripts

TF_ROOT_DIR?=.
TF_INVENTORY_DIR?= $(TF_ROOT_DIR)/inventory
TF_INVENTORY_FILENAME?=
TF_INVENTORY_USE_SERVICE_NAME?=false
TF_TARGET?=
TF_AUTO_APPROVE?=
TF_ARGUMENTS?=
TF_STATE_PATH?=
ENVIRONMENT?=
DATACENTRE?=
SERVICE?=
GITLAB_PROJECT_ID?=

PYTHON ?= python
PYTHON_SWITCHES_FOR_PYLINT = --disable "duplicate-code"

TIMESTAMP=$(shell date +%s)

GENERATE_INVENTORY_ARGS?=

TF_STATE_MANAGEMENT_TARGETS = taint untaint state-rm state-show
TF_STATE_MANAGEMENT_TARGETS_MULTI_ARG = state-import state-mv
TF_STATE_BACKUP_FILE = /tmp/$(SERVICE).terraform.$(TIMESTAMP).tfstate.bak

ifneq ($(TF_TARGET),)
ifneq ($(filter $(firstword $(MAKECMDGOALS)),$(TF_STATE_MANAGEMENT_TARGETS)),)
    TF_ARGUMENTS := '$(TF_TARGET)' $(TF_ARGUMENTS)
else ifneq ($(filter $(firstword $(MAKECMDGOALS)),$(TF_STATE_MANAGEMENT_TARGETS_MULTI_ARG)),)
    TF_ARGUMENTS := $(shell sed "s/\(.*\) \(.*\)/'\1' \2/" <<< $$TF_TARGET) $(TF_ARGUMENTS)
else
    TF_ARGUMENTS := $(TF_ARGUMENTS) -target='$(TF_TARGET)'
endif
endif

ifeq ($(TF_AUTO_APPROVE),true)
    TF_ARGUMENTS := $(TF_ARGUMENTS) -auto-approve
endif

ifneq ($(TF_STATE_PATH),)
    override GENERATE_INVENTORY_ARGS := $(GENERATE_INVENTORY_ARGS) -i $(TF_STATE_PATH)
endif

ifneq ($(TF_INVENTORY_FILENAME),)
    override GENERATE_INVENTORY_ARGS := $(GENERATE_INVENTORY_ARGS) -f $(TF_INVENTORY_FILENAME)
endif

ifeq ($(TF_INVENTORY_USE_SERVICE_NAME),true)
ifneq ($(SERVICE),)
    override GENERATE_INVENTORY_ARGS := $(GENERATE_INVENTORY_ARGS) -f $(SERVICE).inventory.yml
endif
endif

ifneq ($(DATACENTRE),)
    override GENERATE_INVENTORY_ARGS := $(GENERATE_INVENTORY_ARGS) -d $(DATACENTRE)
endif

ifneq ($(ENVIRONMENT),)
    override GENERATE_INVENTORY_ARGS := $(GENERATE_INVENTORY_ARGS) -e $(ENVIRONMENT)
endif

ifneq ($(SERVICE),)
    override GENERATE_INVENTORY_ARGS := $(GENERATE_INVENTORY_ARGS) -s $(SERVICE)
endif

orch-check-service:
ifndef SERVICE
	$(error SERVICE is undefined)
endif

orch-check-target:
ifndef TF_TARGET
	$(error TF_TARGET is undefined)
endif

vars:  ## Current variables
	@echo "DATACENTRE=$(DATACENTRE)"
	@echo "ENVIRONMENT=$(ENVIRONMENT)"
	@echo "SERVICE=$(SERVICE)"
	@echo "GITLAB_PROJECT_ID=$(GITLAB_PROJECT_ID)"
	@echo "TF_ROOT_DIR=$(TF_ROOT_DIR)"
	@echo "TF_INVENTORY_DIR=$(TF_INVENTORY_DIR)"
	@echo "TF_TARGET=$(TF_TARGET)"
	@echo "TF_HTTP_ADDRESS=$(TF_HTTP_ADDRESS)"
	@echo "TF_HTTP_LOCK_ADDRESS=$(TF_HTTP_LOCK_ADDRESS)"
	@echo "TF_HTTP_UNLOCK_ADDRESS=$(TF_HTTP_UNLOCK_ADDRESS)"
	@echo "GENERATE_INVENTORY_ARGS=$(GENERATE_INVENTORY_ARGS)"

lint: ## Lint terraform and python code
	@echo "Linting Terraform Code"
	@make tf-lint
	@echo "Linting Python Code"
	@make python-lint

format: ## Format terraform and python code
	@echo "Formatting Terraform Code"
	@make tf-format
	@echo "Formatting Python Code"
	@make python-format

init: orch-check-service ## Initiate Terraform on the local environment
	@terraform -chdir=$(TF_ROOT_DIR) init --upgrade $(TF_ARGUMENTS)

clean: orch-check-service ## Removes terraform module and state caches. Requires init to be executed
	@rm -rf $$(find $(TF_ROOT_DIR) -name ".terraform*" | xargs)

re-init: clean init

state-backup: ## Backup the current state
	@terraform -chdir=$(TF_ROOT_DIR) state pull > $(TF_STATE_BACKUP_FILE)
	@echo "Backed up state to: '$(TF_STATE_BACKUP_FILE)'"

apply: orch-check-service state-backup ## Apply changes to the cluster. Filter with TF_TARGET
	@terraform -chdir=$(TF_ROOT_DIR) apply $(TF_ARGUMENTS)

plan: orch-check-service ## Check changes to the cluster. Filter with TF_TARGET
	@terraform -chdir=$(TF_ROOT_DIR) plan $(TF_ARGUMENTS)

destroy: orch-check-service state-backup ## Destroy cluster. Filter with TF_TARGET
	@terraform -chdir=$(TF_ROOT_DIR) destroy $(TF_ARGUMENTS)

output: orch-check-service state-backup ## Output cluster state. Filter with TF_TARGET
	@terraform -chdir=$(TF_ROOT_DIR) output $(TF_ARGUMENTS)

plan-destroy: orch-check-service ## Check changes to the cluster in destroy phase. Filter with TF_TARGET
	@terraform -chdir=$(TF_ROOT_DIR) plan -destroy $(TF_ARGUMENTS)

refresh: orch-check-service ## Update the state on the backend. Filter with TF_TARGET
	@terraform -chdir=$(TF_ROOT_DIR) refresh $(TF_ARGUMENTS)

state-list: orch-check-service ## List the resources in the state
	@terraform -chdir=$(TF_ROOT_DIR) state list $(TF_ARGUMENTS)

state-pull: orch-check-service ## Pull the remote state to a local state file
	@terraform -chdir=$(TF_ROOT_DIR) state pull $(TF_ARGUMENTS) > .terraform.tfstate
	@cp .terraform.tfstate .terraform.tfstate.bak

state-show: orch-check-service ## Show the resources in the state
	@terraform -chdir=$(TF_ROOT_DIR) state show $(TF_ARGUMENTS)

state-push: orch-check-service state-backup ## Push the local state to the remote
	@read -r -p "Are you sure you want to push the state at \".terraform.tfstate\" ? [y/N] " response; \
	if [ "$$response" = "y" ] || [ "$$response" = "Y" ] | [ "$$response" = "yes" ]; then \
		cat .terraform.tfstate | terraform -chdir=$(TF_ROOT_DIR) state push $(TF_ARGUMENTS) -; \
	fi

state-import: orch-check-service state-backup ## Import resources to the state
	@read -r -p "Are you sure you want to import \"$(TF_TARGET)\" ? [y/N] " response; \
	if [ "$$response" = "y" ] || [ "$$response" = "Y" ] | [ "$$response" = "yes" ]; then \
		terraform -chdir=$(TF_ROOT_DIR) import $(TF_ARGUMENTS); \
	fi

state-mv: orch-check-service state-backup ## Move resources in the state
	@read -r -p "Are you sure you want to move \"$(TF_TARGET)\" ? [y/N] " response; \
	if [ "$$response" = "y" ] || [ "$$response" = "Y" ] | [ "$$response" = "yes" ]; then \
		terraform -chdir=$(TF_ROOT_DIR) state mv $(TF_ARGUMENTS); \
	fi

state-rm: orch-check-service orch-check-target state-backup ## Remove a resource in the state
	@read -r -p "Are you sure you want to remove \"$(TF_TARGET)\" ? [y/N] " response; \
	if [ "$$response" = "y" ] || [ "$$response" = "Y" ] | [ "$$response" = "yes" ]; then \
		terraform -chdir=$(TF_ROOT_DIR) state rm $(TF_ARGUMENTS); \
	fi

taint: orch-check-service orch-check-target ## Taint state resources. Filter with TF_TARGET
	@terraform -chdir=$(TF_ROOT_DIR) taint $(TF_ARGUMENTS)

untaint: orch-check-service orch-check-target ## Untaint state resources. Filter with TF_TARGET
	@terraform -chdir=$(TF_ROOT_DIR) untaint $(TF_ARGUMENTS)

generate-inventory:
	@if [ -z "$(SERVICE)" ]; then \
		echo "Generating inventory for the whole environment"; \
		SERVICES=$$(ls -d $(TF_ROOT_DIR)* | sed "s#$(TF_ROOT_DIR)##g"); \
		for TARGET_SERVICE in $$SERVICES; do \
			echo "Generating inventory for service: '$$TARGET_SERVICE'"; \
			$(PYTHON) scripts/tfstate_to_ansible_inventory.py \
			-o $(TF_INVENTORY_DIR) $(GENERATE_INVENTORY_ARGS) \
			-s $$TARGET_SERVICE \
			-f $$TARGET_SERVICE.inventory.yml; \
			echo ""; \
		done \
	else \
		echo "Generating inventory for service: '$(SERVICE)'"; \
		$(PYTHON) scripts/tfstate_to_ansible_inventory.py -o $(TF_INVENTORY_DIR) $(GENERATE_INVENTORY_ARGS); \
	fi \

help: ## Show Help
	@echo ""
	@echo "Vars:"
	@$(MAKE) vars;
	@echo ""
	@echo "Targets:"
	@$(MAKE) help-print-targets;
